unit uMagnifier;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, Qt, XLib;

type
  TfrmMagnifier = class(TForm)
    Timer_Grab: TTimer;
    procedure Timer_GrabTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseLeave(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMagnifier: TfrmMagnifier;
  mScreen: TScreen;
  ScreenHeight: integer;
  ScreenWidth: integer;
  RectGrabbed: TBitmap;
  BlockHeight: integer;
  BlockWidth: integer;
  MousePos: TPoint;
  mOnForm: boolean;
  
implementation

uses uSettings;

{$R *.xfm}

procedure TfrmMagnifier.Timer_GrabTimer(Sender: TObject);
var Root  : TWindow;
    Child : TWindow;
    Dummy : Integer;
    X : integer;
    Y : integer;
begin
     GetCursorPos(MousePos);
     X:=MousePos.X;
     Y:=MousePos.Y;
     if XQueryPointer(QtDisplay, QWidget_winID(Application.Desktop),
                      @Root, @Child, @Dummy, @Dummy, @Dummy, @Dummy, @Dummy)<>0 then begin

           if (ScreenWidth-X) > BlockWidth then X:=X
           else X:=ScreenWidth-BlockWidth;

           if Y<(ScreenHeight-BlockHeight) then  Y:=Y
           else if Y>(ScreenHeight-BlockHeight) then Y:=ScreenHeight-BlockHeight;

           QPixmap_grabWindow(RectGrabbed.Handle,Root,X,Y,BlockWidth,BlockHeight);

     end;

     Canvas.StretchDraw(Rect(0,0,frmMagnifier.Width,frmMagnifier.Height),RectGrabbed);

end;

procedure TfrmMagnifier.FormCreate(Sender: TObject);
begin
     mOnForm:=False;

     mScreen:=GetScreen;
     ScreenHeight:=mScreen.Height;
     ScreenWidth:=mScreen.Width;

     with frmMagnifier do
     begin
          Top:=0;
          Left:=0;
          Width:=ScreenWidth;
          Height:=250;
          Constraints.MaxHeight:=ScreenHeight div 2;
     end;

       RectGrabbed := TBitmap.Create;
       XGrabPointer(QtDisplay,  QWidget_winID(Self.Handle), 1, ButtonPressMask,
                    GrabModeAsync, GrabModeAsync, 0, 0, 0);
end;

procedure TfrmMagnifier.FormShow(Sender: TObject);
begin
     Timer_Grab.Enabled:=True;
end;

procedure TfrmMagnifier.FormResize(Sender: TObject);
begin
      try
          Timer_Grab.Enabled:=False;
          BlockWidth:=frmMagnifier.ClientWidth div Magnification;
          BlockHeight:=frmMagnifier.ClientHeight div Magnification;
          Timer_Grab.Enabled:=True;
      except

      end;


end;

procedure TfrmMagnifier.FormMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
     //mOnForm:=True;

end;

procedure TfrmMagnifier.FormMouseLeave(Sender: TObject);
begin
     //mOnForm:=False;
end;

end.
