{ *************************************************************************** }
{                                                                             }
{ WindowsXP-like Magnifier                                                    }
{                                                                             }
{ Copyright (c) 2004 Sergey Mishin <mishinmail@mail.ru>                       }
{                                                                             }
{ This program is free software; you can redistribute it and/or               }
{ modify it under the terms of the GNU General Public                         }
{ License as published by the Free Software Foundation; either                }
{ version 2 of the License, or (at your option) any later version.            }
{                                                                             }
{                                                                             }
{ This program is distributed in the hope that it will be useful,             }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of              }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           }
{ General Public License for more details.                                    }
{                                                                             }
{ You should have received a copy of the GNU General Public License           }
{ along with this program; see the file COPYING.  If not, write to            }
{ the Free Software Foundation, Inc., 59 Temple Place - Suite 330,            }
{ Boston, MA 02111-1307, USA.                                                 }
{                                                                             }
{ *************************************************************************** }
unit uSettings;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QExtCtrls, Qt, XLib;

type
  TfrmSettings = class(TForm)
    Label1: TLabel;
    cboMagnification: TComboBox;
    Tracking: TGroupBox;
    chkFollowMouse: TCheckBox;
    cboFollowKeyboard: TCheckBox;
    cboFollowTextEdit: TCheckBox;
    GroupBox1: TGroupBox;
    cboInvertColors: TCheckBox;
    cboStartMinimized: TCheckBox;
    cboShowMag: TCheckBox;
    btnHelp: TButton;
    btnExit: TButton;
    imgHand: TImage;
    procedure FormShow(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure cboMagnificationChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSettings: TfrmSettings;
  Magnification: integer;
const
  crWinHand=100;

implementation

uses uMagnifier;

{$R *.xfm}

procedure TfrmSettings.FormShow(Sender: TObject);
begin
    cboMagnification.ItemIndex:=1;
    Magnification:=2;
    BlockWidth:=frmMagnifier.ClientWidth div Magnification;
    BlockHeight:=frmMagnifier.ClientHeight div Magnification;
    frmMagnifier.Show;

end;

procedure TfrmSettings.btnExitClick(Sender: TObject);
begin
     Close;
end;

procedure TfrmSettings.cboMagnificationChange(Sender: TObject);
begin

     Magnification:=StrToInt(cboMagnification.Text);
     BlockWidth:=frmMagnifier.ClientWidth div Magnification;
     BlockHeight:=frmMagnifier.ClientHeight div Magnification;
     frmMagnifier.Timer_Grab.Enabled:=True;
end;

procedure TfrmSettings.FormCreate(Sender: TObject);
begin
     QForms.Screen.Cursors[crWinHand]:=QCursor_create(imgHand.Picture.Bitmap.Handle,0,0);
     QForms.Screen.Cursors[crHandPoint]:= QForms.Screen.Cursors[crWinHand];
end;

end.
